/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.hardware.registers;

import j8086emu.model.interfaces.Widgetable;
import j8086emu.view.TextWidget;

import java.util.HashMap;

/**
 *
 * @author sone
 */
public class FlagsRegister extends HashMap implements Widgetable {

    private class Flag {

        private boolean state;

        public Flag(boolean state) {
            this.state = state;
        }

        public boolean isState() {
            return state;
        }

        public void setState(boolean state) {
            this.state = state;
        }
    }

    public FlagsRegister() {
        this.put("CF", new Flag(false));
        this.put("PF", new Flag(false));
        this.put("AF", new Flag(false));
        this.put("ZF", new Flag(false));
        this.put("SF", new Flag(false));
        this.put("TF", new Flag(false));
        this.put("IF", new Flag(false));
        this.put("DF", new Flag(false));
        this.put("OF", new Flag(false));
    }

    public boolean getFlag(String name) {
        return ((Flag) get(name)).isState();
    }

    public void setFlag(String name, boolean state){
        ((Flag) get(name)).setState(state);
    }

    public void setWidget(TextWidget wid) {
        updateWidget();
    }

    public void removeWidget() {
    }

    public void updateWidget() {
    }
}
