package j8086emu.model.hardware.registers;

import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.types.VarTypes;

/**
 * J8086emu
 * User: Sone
 * Date: 23.03.2010
 * Time: 21:17:42
 */
public class RegLowBits implements Variable{
    private GeneralRegister reg;

    public RegLowBits(GeneralRegister reg) {
        this.reg = reg;
    }

    public int getData() {
        return reg.getLowBits();  //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setData(int arg) {
        reg.setLowBits(arg);
    }

    public VarTypes getType() {
        return VarTypes.reg8;
    }
}
