package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.progcode.VarParser;

/**
 * @author vlad
 */
public class Cbw extends Performable {

    private CPU cpu;

    public Cbw(VarParser varParser) {
        this.cpu = varParser.getCpu();
    }

    public void perform(String msg) throws InvalidArgumentExeption {
//        GeneralRegister ax = (GeneralRegister) nameMap.getObgectFromName("AX");
        // TODO fix incorrect sign checking (it's always > 0, because register's ByteDataFormats kepts positive numbers)
//        if (ax.getLowBits() < 0) {
//            ax.setHighBits(0xFF);
//        } else {
//            ax.setHighBits(0x00);
//        }
        if (cpu.getRegData("AL") < 0)
            cpu.setRegData("AH", 0xff);
        else
            cpu.setRegData("AH", 0x00);
    }
}
