package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.progcode.VarParser;

/**
 * @author vlad
 */
public class Cwd extends Performable {

    private CPU cpu;

    public Cwd(VarParser varParser) {
        this.cpu = varParser.getCpu();
    }

    public void perform(String msg) throws InvalidArgumentExeption {

        /*if (ax.getData() < 0) {
            dx.setData(0xFFFF);
        } else {
            dx.setData(0x0000);
        }*/

        if (cpu.getRegData("AX") < 0)
            cpu.setRegData("DX", 0xffff);
        else
            cpu.setRegData("DX", 0x0000);
    }
}
