package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.VarParser;
import j8086emu.model.progcode.types.VarTypes;

/**
 * @author vlad
 *         Date: 09.04.2010
 *         Time: 10:52:40
 */
public class JeJz extends ConditionalJump {

    public JeJz(VarParser varParser) {
        super(varParser);
    }

    @Override
    protected boolean isAllowCondition() {
        return cpu.getFlagState("ZF");
    }
}
