package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.progcode.VarParser;

/**
 * @author vlad
 *         Date: 09.04.2010
 *         Time: 10:57:40
 */
public class JleJng extends ConditionalJump {
    public JleJng(VarParser varParser) {
        super(varParser);
    }

    @Override
    protected boolean isAllowCondition() {
        return (cpu.getFlagState("SF") != cpu.getFlagState("OF") || cpu.getFlagState("ZF"));
    }
}
