package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.VarParser;

/**
 * @author vlad
 */
public class ShlSal extends Performable {
    private final int NUM_OF_ARGS = 2;
    private final VarParser varParser;

    public ShlSal(VarParser varParser) {
        this.varParser = varParser;
    }

    public void perform(String msg) throws InvalidArgumentExeption {

        /*String[] args = StringSplitter.split(msg);
        Variable[] var = new Variable[NUM_OF_ARGS];
        for (int i = 0; i < var.length; i++) {
            var[i] = nameMap.getObgectFromName(args[i]);
        }*/
        Variable[] var = varParser.getVar(msg, NUM_OF_ARGS);
        var[0].setData(var[0].getData() << var[1].getData());
    }
}
