package j8086emu.model.progcode.types;

import j8086emu.model.exeptions.RamOutOfRangeExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.VarParams;

/**
 * J8086emu
 * User: Sone
 * Date: 23.03.2010
 * Time: 19:20:29
 */
public class DBType implements Variable {

    private CPU cpu;
    private VarParams params;
    private VarTypes type;

    public DBType(CPU cpu, VarParams params, VarTypes type) {
        this.cpu = cpu;
        this.params = params;
        this.type = type;
    }

    public int getData() {
        return cpu.getRamData(params.getAdress());
    }

    public void setData(int arg) {
        try {
            cpu.setRamData(params.getAdress(), arg);
        } catch (RamOutOfRangeExeption ramOutOfRangeExeption) {
            ramOutOfRangeExeption.printStackTrace();
        }
    }

    public VarTypes getType() {
        return type;
    }

}
