package j8086emu.model.progcode.types;

import j8086emu.model.interfaces.Variable;

/**
 * @author vlad
 *         Date: 09.04.2010
 *         Time: 12:17:48
 */
public class Label implements Variable {
    private VarTypes type;
    private int[] address = new int[2];

    public Label(VarTypes type) {
        this.type = type;
    }

    public int getData() {
        return address[1];
    }

    public int getSegAddr() {
        return address[0];
    }

    public void setData(int offset) {
        address[1] = offset;
    }

    public void setSegAddr(int addr) {
        address[0] = addr;
    }

    public VarTypes getType() {
        return type;
    }
}
