/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package j8086emu.model.utils;

/**
 * @author Sone
 */
public class Data {
    public static String intToHex(Integer data, int size) {
        if (data < 0) {
            int absData = java.lang.Math.abs(data);
            String binData = Integer.toBinaryString(absData);
            if (size == 2) {
                for (int i = binData.length(); i < 8; i++) {
                    binData = "0" + binData;
                }
            }
            if (size == 4) {
                for (int i = binData.length(); i < 16; i++) {
                    binData = "0" + binData;
                }
            }
            String invBinData = invertBinString(binData);
            int invData = Integer.parseInt(invBinData, 2) + 1;
            String result = Integer.toHexString(invData);
            if (result.length() == 4) return result;
            else {
                if (result.length() > 4) {
                    return result.substring(result.length() - 4);
                } else {
                    for (int i = result.length(); i < 4; i++) {
                        result = "0" + result;
                    }
                    return result;
                }
            }
        } else {

            String hexData = Integer.toHexString(data).toUpperCase();
            for (int i = hexData.length(); i < size; i++) {
                hexData = "0" + hexData;
            }
            if (hexData.length() > size) {
                hexData = hexData.substring(hexData.length() - size);
            }
            return hexData;
        }
    }

    public static int hexToInt(String hex, int size) {
        if (hex.length() > 4) {
            hex = hex.substring(4);
        }
        int i = Integer.parseInt(hex.toUpperCase(), 16);
        String invBin = invertBinString(Integer.toBinaryString(i));
        if (invBin.length() < size * 4) {
            return i;
        } else {
            return -(Integer.parseInt(invBin, 2) + 1);
        }
    }

    private static String invertBinString(String binData) {
        String invBinData = "";
        for (int i = 0; i < binData.length(); i++) {
            if (binData.charAt(i) == '0') {
                invBinData += "1";
            } else {
                invBinData += "0";
            }
        }
        return invBinData;
    }

    public static boolean evenLowSetBits(String hex) {
        int num = Integer.parseInt(hex.substring(2), 16);
        System.out.println(Integer.toHexString(num));
        String bin = Integer.toBinaryString(num);
        int countSetBits = 0;
        for (int i = 0; i < bin.length(); i++) {
            if (bin.charAt(i) == '1') countSetBits++;
        }
        return (countSetBits % 2) == 0;
    }

    public static boolean secondQuarterOverflow(String first, String second) {
        int a = Integer.parseInt(first, 16);
        int b = Integer.parseInt(second, 16);
        return (((a % 256) + (b % 256)) > 255);
    }

    public static boolean borrowHighOrderBit(String first, String second) {
        int a = Integer.parseInt(first, 16);
        int b = Integer.parseInt(second, 16);
        return (a+b) > 65535;
    }

    public static String negToPosHex(String i) {
        return null;
    }

    public static String negToPosNum(String i) {
        return null;
    }
}
