package j8086emu.model.utils;

/**
 * @author vlad
 *         Date: 23.04.2010
 *         Time: 12:20:32
 */
public class Hex {
    
    static public String toHexString(int num, int width) {
		String txt = Integer.toHexString(num);

		int len = txt.length();
		if(len<width){
			StringBuffer sb = new StringBuffer();
			for(;len<width;len++){
				sb.append('0');
			}
			txt = sb.append(txt).toString();
		} else if(len>width){
			txt = txt.substring(len-width, len);
		}

		return txt;
	}

	static public String toHexStringUnsigned(int num, int width) {
		String txt = Integer.toHexString(num);

		int len = txt.length();
		if(len>width){
			txt = txt.substring(len-width, len);
		}
		return txt;
	}


	static public String toHexStringSigned(int num, int width) {
		boolean negative = false;

		if(num<0) {
			num=-num;
			negative = true;
		}

		String txt = Integer.toHexString(num);

		int len = txt.length();
		if(len>width){
			txt = txt.substring(len-width, len);
		}

		if(negative==true){
			txt="-0x" + txt;}
		else{
			txt="+0x" + txt;}

		return txt;
	}
}
