package j8086emu.model.progcode;

import org.junit.*;

import static org.junit.Assert.assertEquals;

/**
 *
 * @author vlad
 */
public class CodeOptimizerTest {

    public CodeOptimizerTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    @Test
    public void testOptimize() {
        System.out.println("optimizeTest");
        ProgramCode programCode = new ProgramCode();
        programCode.addString("MOV     ax    ,    bx");
        programCode.addString("");
        programCode.addString("; Now will be suddenly!");
        programCode.addString("int   80h   ;Holy shit! It's interrupt!!! Suddenly!");
        CodeOptimizer codeOptimizer = new CodeOptimizer();
        codeOptimizer.optimize(programCode);
        String expResult = "MOV ax,bx\nint 80h\n";
        String result = programCode.getStringOn(0) + programCode.getStringOn(1);
        System.out.println(expResult);
        System.out.println(result);
        assertEquals(expResult, result);
    }

}