package j8086emu.model.progcode;

import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.progcode.instructions.Add;
import j8086emu.model.progcode.instructions.Sub;
import org.junit.*;

import static org.junit.Assert.assertEquals;

/**
 *
 * @author vlad
 */
public class InstructionsMapTest {

    public InstructionsMapTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    @Test
    public void testGet() throws Exception {
        System.out.println("InstructionsMap get() test");
        //HardwareMap hardwareMap = new HardwareMap();
        CPU cpu = new CPU();
        InstructionsMap instructionsMap = new InstructionsMap(cpu);
        NameMap nameMap = new NameMap(cpu);
        Performable expResult1 = new Add(new VarParser(nameMap));
        Performable expResult2 = new Sub(new VarParser(nameMap));
        Performable expResult3 = null;
        Performable result1 = instructionsMap.get("[Aa][Dd][Dd] \\S+,\\S+\n");
        Performable result2 = instructionsMap.get("[Ss][Uu][Bb] \\S+,\\S+\n");
        Performable result3 = instructionsMap.get("Hui");
        assertEquals(expResult1.getClass(), result1.getClass());
        System.out.println(result1.getClass());
        System.out.println(result2.getClass());
        assertEquals(expResult2.getClass(), result2.getClass());
        
        assertEquals(expResult3, result3);        
    }

//    @Test
//    public void testKeyArray() throws Exception {
//        System.out.println("InstructionsMap keyArray() test");
//        HardwareMap hardwareMap = new HardwareMap();
//        InstructionsMap instructionsMap = new InstructionsMap(hardwareMap);
//        ArrayList expResult = new ArrayList();
//        expResult.add("[Mm][Oo][Vv] \\w+,\\w+\n");
//        expResult.add("[Aa][Dd][Dd] \\w+,\\w+\n");
//        expResult.add("[Ss][Uu][Bb] \\w+,\\w+\n");
//        expResult.add("[Ii][Nn][Tt] \\w+\n");
//        ArrayList result = new ArrayList();
//        String[] instructs = instructionsMap.keyArray();
//        for(String pattern : instructs) {
//            result.add(pattern);
//            System.out.println(pattern);
//        }
//        assertTrue(result.containsAll(expResult));
//    }
}