/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package j8086emu.model.progcode.instructions;

import j8086emu.model.hardware.formats.GeneralRegisterDataFormat;
import j8086emu.model.utils.DigitsParser;
import org.junit.*;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

/**
 *
 * @author sone
 */
public class DigitsParserTest {

    public DigitsParserTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of parse method, of class DigitsParser.
     * @throws Exception
     */
    @Test
    public void testParse() throws Exception {
        System.out.println("parse");
        String msg1 = "11111111b";
        String msg2 = "FFh";
        String msg3 = "255";
        String msg4 = "sgsdhh";
        DigitsParser instance = new DigitsParser();
        GeneralRegisterDataFormat expResult = new GeneralRegisterDataFormat(null, 255);
        GeneralRegisterDataFormat result1 = (GeneralRegisterDataFormat) instance.parse(msg1);
        GeneralRegisterDataFormat result2 = (GeneralRegisterDataFormat) instance.parse(msg2);
        GeneralRegisterDataFormat result3 = (GeneralRegisterDataFormat) instance.parse(msg3);
        try {
            instance.parse(msg4);
        } catch (Exception e) {
            assertTrue(true);
        }
        assertEquals(expResult.getData(), result1.getData());
        assertEquals(expResult.getData(), result2.getData());
        assertEquals(expResult.getData(), result3.getData());
    }

}