/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.progcode.instructions;

import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.NameMap;
import j8086emu.model.progcode.VarParser;
import org.junit.*;

import static org.junit.Assert.assertTrue;

/**
 *
 * @author sone
 */
public class MovAddSubTest {

    public MovAddSubTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of perform method, of class Mov.
     * @throws Exception
     */
    @Test
    public void testPerform() throws Exception {
        System.out.println("perform MOV");
        NameMap nameMap = new NameMap(new CPU());
        Mov mov = new Mov(new VarParser(nameMap));
        Add add = new Add(new VarParser(nameMap));
        Sub sub = new Sub(new VarParser(nameMap));
        Variable ax = nameMap.getObgectFromName("AX");
        Variable bx = nameMap.getObgectFromName("BX");
        Variable cx = nameMap.getObgectFromName("CX");
        int num = 37;
        int num2 = 45;
        cx.setData(num);
        mov.perform("ax, cx");
        add.perform("ax, cx");
        cx.setData(num2);
        add.perform("bx, cx");
        sub.perform("ax, bx");
        System.out.println(ax.getData() + " " + bx.getData() + " " + cx.getData());
        assertTrue(ax.getData() == num + num - num2);
    }
}
