package j8086emu.model.progcode.instructions;

import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.NameMap;
import j8086emu.model.progcode.VarParser;
import org.junit.*;

import static org.junit.Assert.assertEquals;

/**
 *
 * @author vlad
 */
public class NotTest {

    public NotTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of perform method, of class Not.
     * @throws Exception
     */
    @Test
    public void testPerform() throws Exception {
        System.out.println("Not perform test");
        NameMap nameMap = new NameMap(new CPU());
        Not notInstruction = new Not(new VarParser(nameMap));
        Variable bx = nameMap.getObgectFromName("BX");
        bx.setData(6);
        notInstruction.perform("BX");
        assertEquals(bx.getData() , -6);
    }

}