package j8086emu.model.progcode.instructions;

import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.NameMap;
import j8086emu.model.progcode.VarParser;
import org.junit.*;

import static org.junit.Assert.assertTrue;

/**
 *
 * @author vlad
 */
public class OrTest {

    public OrTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of perform method, of class Or.
     * @throws Exception
     */
    @Test
    public void testPerform2() throws Exception {
       String regName = "BX";
        int regDigit = 7;
        int digit = 17;
        int trueResult = 23;
        System.out.println("Or perform test 2 arguments");
        NameMap nameMap = new NameMap(new CPU());
        Or orInstruction = new Or(new VarParser(nameMap));
        Variable register = nameMap.getObgectFromName(regName);
        register.setData(regDigit);
        orInstruction.perform(regName + ", " + digit);
        assertTrue(register.getData() == trueResult);
    }

}