package j8086emu.model.progcode;

/**
 *
 * @author vlad
 */
public class CodeOptimizer {
    // TODO: delete unexpected spaces

    public void optimize(ProgramCode programCode) {
        String[] codeStrings = programCode.getCode();
        programCode.clearCode();
        for (String codeStr : codeStrings) {
            codeStr = codeStr.replaceAll(";.*", "").replaceAll(" {2,}", " ").replaceAll(" ?, ?", ",").trim();
            if (codeStr.matches(".+: .+")) {
                String codeStrLabel = codeStr.substring(0, codeStr.indexOf(" "));
                programCode.addString(codeStrLabel + "\n");
                codeStr = codeStr.replaceFirst(codeStrLabel + " ", "");
            }
            if (!codeStr.isEmpty()) {
                programCode.addString(codeStr + "\n");
            }
        }        
    }
}
