package j8086emu.model.progcode;

/**
 * @author vlad
 *         Date: 20.04.2010
 *         Time: 12:53:49
 */
public class InstructionStructure {
    private String offset;
    private String hexInstruction;
    private String stringInstruction;
    private boolean isData;

    public InstructionStructure(String offset, String hexInstruction, boolean isData) {
        this.offset = optimizeString(offset);
        this.hexInstruction = optimizeString(hexInstruction);
        this.isData = isData;
    }

    public String getOffset() {
        return offset;
    }

    public String getHexInstruction() {
        return hexInstruction;
    }

    public boolean isData() {
        return isData;
    }

    public String getStringInstruction() {
        return stringInstruction;
    }

    public void setStringInstruction(String stringInstruction) {
        this.stringInstruction = stringInstruction;
    }

    private String optimizeString(String str) {
        return str.replaceAll(" ", "");
    }
}
