package j8086emu.model.progcode;

import j8086emu.model.progcode.types.VarTypes;

import java.util.HashMap;

/**
 * @author vlad
 *         Date: 07.04.2010
 *         Time: 17:48:02
 */
public class LabelFinder {

    private VariableMap varMap;

    public LabelFinder(NameMap nm) {
        varMap = nm.getVariableMap();
    }

    public void allocateLabel(String name, int offset) {
        name = name.toUpperCase().replaceFirst(":", "").trim();
        varMap.addVar(name, VarTypes.rel, 0); // TODO: other label types for Jmp
        varMap.get(name).setData(offset);
    }
}
