package j8086emu.model.progcode;

import java.util.ArrayList;

/**
 *
 * @author vlad
 */
public class ProgramCode {

    private final ArrayList code = new ArrayList<String>();

    public String[] getCode() {
        // actions below is for type casting Object[] to String[]
        String[] codeStrings = new String[code.size()];
        for (int i = 0; i < codeStrings.length; i++) {
            codeStrings[i] = (String) code.get(i);
        }
        return codeStrings;
    }

    public void clearCode() {
        code.clear();
    }

    public void addString(String str) {
        code.add(str);
    }

    public String getStringOn(int num) {
        return (String) code.get(num);
    }
}
