package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.progcode.VarParser;

/**
 * @author vlad
 *         Date: 09.04.2010
 *         Time: 10:56:26
 */
public class JneJnz extends ConditionalJump {
    public JneJnz(VarParser varParser) {
        super(varParser);
    }

    @Override
    protected boolean isAllowCondition() {
        return !cpu.getFlagState("ZF");
    }
}
