/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.VarParser;

/**
 *
 * @author sone
 */
public class Pop extends Performable{

    private VarParser varParser;
    private CPU cpu;
    private final int NUM_OF_ARGS = 1;

    public Pop(VarParser varParser) {
        this.varParser = varParser;
        this.cpu = varParser.getCpu();
    }

    public void perform(String msg) throws InvalidArgumentExeption {
//        String[] args = StringSplitter.split(msg);
//        Variable[] var = new Variable[NUM_OF_ARGS];

        Variable[] var = varParser.getVar(msg, NUM_OF_ARGS);
        cpu.setRegData("SP", cpu.getRegData("SP") + 2);
        int cellNum = cpu.getRegData("CS") * 16 + cpu.getRegData("SP");
        var[0].setData(cpu.getRamData(cellNum));
    }
}
