package j8086emu.view;

import javax.swing.*;
import java.awt.event.*;

public class DialogWithText extends JDialog {
    private JPanel contentPane;
    private JButton buttonCancel;
    private JLabel label1;
    private String text;

    public DialogWithText(String text) {
        setContentPane(contentPane);
        setModal(true);
        this.text = text;
        label1.setText(text);

        buttonCancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onCancel();
            }
        });

// call onCancel() when cross is clicked
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                onCancel();
            }
        });

// call onCancel() on ESCAPE
        contentPane.registerKeyboardAction(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onCancel();
            }
        }, KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
    }

    private void onCancel() {
// add your code here if necessary
        dispose();
    }

    private void createUIComponents() {
        label1 = new JLabel();
    }

    public static void showMessage(String msg) {
        DialogWithText errorDialog = new DialogWithText(msg);
        errorDialog.setSize(480, 240);
        errorDialog.setVisible(true);
    }
}
