package j8086emu.view;

import javax.swing.*;

/**
 * J8086emu
 * User: Sone
 * Date: 28.04.2010
 * Time: 15:23:37
 */
public class RowSelector {

    private JTable table;
    private int currentSelection;

    public RowSelector(JTable table) {
        this.table = table;
        currentSelection = 0;
        select();
    }

    public void select(int num) {
        currentSelection = num;
        select();
    }

    private void select() {
        table.getSelectionModel().setSelectionInterval(currentSelection, currentSelection);
    }

    public void selectNext(){
        currentSelection++;
        select();
    }

}
