/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.hardware.formats;

import j8086emu.model.progcode.types.VarTypes;
import org.junit.*;

import static org.junit.Assert.assertTrue;

/**
 * @author Sone
 */
public class GeneralRegisterDataFormatTest {

    public GeneralRegisterDataFormatTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of setData method, of class GeneralRegisterDataFormat.
     */
    @Test
    public void testSetData() {
        System.out.println("setData");
        int data = 5300;
        System.out.println(Integer.toHexString(data));
        GeneralRegisterDataFormat instance = new GeneralRegisterDataFormat(VarTypes.reg16, 0);
        instance.setData(data);
        assertTrue(instance.getData() == data);
    }

    /**
     * Test of getData method, of class GeneralRegisterDataFormat.
     */
    @Test
    public void testGetData() {
        System.out.println("getData");
        int data = 47000;
        System.out.println(Integer.toHexString(data));
        GeneralRegisterDataFormat instance = new GeneralRegisterDataFormat(VarTypes.reg16, 0);
        instance.setData(data);
        System.out.println(instance.getHexData());
        assertTrue(instance.getHexData().equalsIgnoreCase(Integer.toHexString(data)));
    }

    /**
     * Test of getHexData method, of class GeneralRegisterDataFormat.
     */
    @Test
    public void testHexData() {
        System.out.println("HexData");
        int data = 23004;
        System.out.println(Integer.toHexString(data));
        GeneralRegisterDataFormat instance = new GeneralRegisterDataFormat(VarTypes.reg16, 0);
        instance.setData(data);
        assertTrue(instance.getHexData().equalsIgnoreCase(Integer.toHexString(data)));
    }

    /**
     * Test of getLowBits method, of class GeneralRegisterDataFormat.
     */
    @Test
    public void testGetHexBits() {
        System.out.println("HexBits");
        int data = 23004;
        System.out.println(Integer.toHexString(data));
        GeneralRegisterDataFormat instance = new GeneralRegisterDataFormat(VarTypes.reg16, 0);
        instance.setData(data);
        System.out.println(instance.getHexHighBits() + instance.getHexLowBits() + " " + Integer.toHexString(data));
        assertTrue((instance.getHexHighBits() + instance.getHexLowBits()).equals(Integer.toHexString(data).toUpperCase()));
    }

    /**
     * Test of getHexHighBits method, of class GeneralRegisterDataFormat.
     */
    @Test
    public void testGetBits() {
        System.out.println("Bits");
        int data = 23004;
        System.out.println(Integer.toHexString(data));
        GeneralRegisterDataFormat instance = new GeneralRegisterDataFormat(VarTypes.reg16, 0);
        instance.setData(data);
        System.out.println(instance.getHexLowBits() + instance.getHexHighBits());
        assertTrue((instance.getLowBits() + instance.getHighBits() * 256) == (data));

    }

}
