/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.hardware.registers;

import org.junit.*;

import static org.junit.Assert.assertEquals;

/**
 *
 * @author Sone
 */
public class GeneralRegisterTest {

    public GeneralRegisterTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of getData method, of class GeneralRegister.
     */
    @Test
    public void testGetData() {
        System.out.println("getData");
        GeneralRegister instance = new GeneralRegister("AS");
        int data = 23466;
        instance.setData(data);
        int result = instance.getData();
        assertEquals(data, result);
    }

    /**
     * Test of getLowBits method, of class GeneralRegister.
     */
    @Test
    public void testGetBits() {
        System.out.println("getBits");
        GeneralRegister instance = new GeneralRegister("AS");
        instance.setData(34566);
        System.out.println(instance.getLowBits() + instance.getHighBits() * 256 + " " + instance.getData());
        assertEquals(instance.getLowBits() + instance.getHighBits() * 256, instance.getData());
    }

    /**
     * Test of setAllBits method, of class GeneralRegister.
     */
    @Test
    public void testSetBits() {
        System.out.println("setBits");
        GeneralRegister instance = new GeneralRegister("AS");
        instance.setHighBits(234);
        instance.setLowBits(345);
        assertEquals(instance.getLowBits() + instance.getHighBits() * 256, instance.getData());
    }

    /**
     * Test of setHexAllBits method, of class GeneralRegister.
     */
    @Test
    public void testSetHexData() {
        System.out.println("setHexAllBits");
        String hexData = "7fd3";
        GeneralRegister instance = new GeneralRegister("AS");
        instance.setHexData(hexData);
        assertEquals(hexData, Integer.toHexString(instance.getData()));
    }

    @Test
    public void tesIsOverFlow() {
        System.out.println("Overflow");
        GeneralRegister instance = new GeneralRegister("AS");
        instance.setData(100000);
        assertEquals(instance.isOverflow(), true);
        instance.setData(-56);
        assertEquals(instance.isOverflow(), true);
        instance.setData(1234);
        assertEquals(instance.isOverflow(), false);

    }

}
