package j8086emu.model.progcode;

import j8086emu.model.progcode.files.Loader;
import org.junit.*;

import static org.junit.Assert.assertArrayEquals;

/**
 *
 * @author vlad
 */
public class LoaderTest {

    public LoaderTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {        
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {        
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of load method, of class Loader.
     * @throws Exception
     */
    @Test
    public void testLoad() throws Exception {
        System.out.println("loaderTest");
        String selectedFile = new java.io.File("").getAbsolutePath() + "/test_code.asm";
        ProgramCode programCode = new ProgramCode();
        Loader loader = new Loader(programCode, new CodeOptimizer(), new PointerCode());
        loader.load(selectedFile);
        String[] expResult = {"SEGMENT .text\n", "GLOBAL _start\n", "_start:\n", "MOV ax,bx\n"};
        String[] result = programCode.getCode();
        assertArrayEquals(expResult, result);
    }    
}
