package j8086emu.model.progcode;

import org.junit.Test;

import static org.junit.Assert.assertArrayEquals;

/**
 *
 * @author vlad
 */
public class RedactedCodeSaverTest {

    @Test
    public void testSave() throws Exception {
        System.out.println("saveInside redacted code test");
        String text = "MOV cx, dx\nADD ax, 5 ;ax+5";
        ProgramCode programCode = new ProgramCode();
        RedactedCodeSaver redactedCodeSaver = new RedactedCodeSaver(programCode, new CodeOptimizer());
        redactedCodeSaver.save(text);
        String[] expResult = {"MOV cx,dx\n", "ADD ax,5\n"};
        String[] result = programCode.getCode();
        assertArrayEquals(expResult, result);
    }
}