package j8086emu.model.progcode.instructions;

import j8086emu.model.hardware.CPU;
import j8086emu.model.progcode.NameMap;
import j8086emu.model.progcode.VarParser;
import org.junit.*;

import static org.junit.Assert.assertTrue;

/**
 *
 * @author vlad
 */
public class AndTest {

    public AndTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of perform method, of class And.
     * @throws Exception
     */
    @Test
    public void testPerform2() throws Exception {
        String regName = "DX";
        int regDigit = 6;
        int digit = 12;
        int trueResult = 4;
        System.out.println("And perform test 2 arguments");
        CPU cpu = new CPU();
        NameMap nameMap = new NameMap(cpu);
        And andInstruction = new And(new VarParser(nameMap));
        cpu.setRegData(regName, regDigit);
        andInstruction.perform(regName + ", " + digit);
        assertTrue(cpu.getRegData("DX") == trueResult);
    }

}