package j8086emu.model.progcode.instructions;

import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.NameMap;
import j8086emu.model.progcode.VarParser;
import org.junit.*;

import static org.junit.Assert.assertTrue;

/**
 *
 * @author vlad
 */
public class SarTest {

    public SarTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of perform method, of class Sar.
     * @throws Exception
     */
    @Test
    public void testPerform() throws Exception {
        String regName = "CX";
        // TODO test on negative digits
        int regDigit = 164;
        int digit = 2;
        int trueResult = 41;
        System.out.println("Sar perform test");
        NameMap nameMap = new NameMap(new CPU());
        Sar sar = new Sar(new VarParser(nameMap));
        Variable register = nameMap.getObgectFromName(regName);
        register.setData(regDigit);
        sar.perform(regName + ", " + digit);
        assertTrue(register.getData() == trueResult);
    }
}