package j8086emu.model.progcode.instructions;

import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.NameMap;
import j8086emu.model.progcode.VarParser;
import org.junit.*;

import static org.junit.Assert.assertTrue;

/**
 *
 * @author vlad
 */
public class ShlSalTest {

    public ShlSalTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of perform method, of class ShlSal.
     * @throws Exception
     */
    @Test
    public void testPerform() throws Exception {
        String regName = "AX";
        // TODO test on negative digits
        int regDigit = 6;
        int digit = 3;
        int trueResult = 48;
        System.out.println("ShlSal perform test");
        NameMap nameMap = new NameMap(new CPU());
        ShlSal shlSal = new ShlSal(new VarParser(nameMap));
        Variable register = nameMap.getObgectFromName(regName);
        register.setData(regDigit);
        shlSal.perform(regName + ", " + digit);
        assertTrue(register.getData() == trueResult);
    }

}