package j8086emu.model.progcode.instructions;

import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.NameMap;
import j8086emu.model.progcode.VarParser;
import org.junit.*;

import static org.junit.Assert.assertTrue;

/**
 *
 * @author vlad
 */
public class ShrTest {

    public ShrTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of perform method, of class Shr.
     * @throws Exception
     */
    @Test
    public void testPerform() throws Exception {
        String regName = "DX";
        int regDigit = 180;
        int digit = 4;
        int trueResult = 11;
        System.out.println("Shr perform test");
        NameMap nameMap = new NameMap(new CPU());
        Shr shr = new Shr(new VarParser(nameMap));
        Variable register = nameMap.getObgectFromName(regName);
        register.setData(regDigit);
        shr.perform(regName + ", " + digit);
        assertTrue(register.getData() == trueResult);
    }

}