package j8086emu.model.progcode.types;

import j8086emu.model.hardware.CPU;
import j8086emu.model.progcode.VarParams;
import junit.framework.TestCase;

/**
 * J8086emu
 * User: Sone
 * Date: 25.03.2010
 * Time: 20:13:37
 */
public class DWTypeTest extends TestCase {
    public void testGetData() throws Exception {
        CPU cpu = new CPU();
        DWType dw = new DWType(cpu,new VarParams(VarTypes.dw, 0x0023), null);
        assertEquals(dw.getData(), 0);
    }

    public void testSetData() throws Exception {
        CPU cpu = new CPU();
        DWType dw = new DWType(cpu,new VarParams(VarTypes.dw, 0x0023), null);
        dw.setData(123);
        System.out.println(cpu.getRamData(0x0023)* 256 + cpu.getRamData(0x0024) + " - " + dw.getData());
        assertEquals(dw.getData(), cpu.getRamData(0x0023)* 256 + cpu.getRamData(0x0024));
    }
}
